

#include <iostream>
#include <fstream>
#include <ctype.h>
#include <string.h>

#include "dict.h"

#define         TROW    4
#define         ROWS    50

#undef COLOR

char loadword[128], twlword[128], sowword[128];
ofstream indx;
ifstream input;

Dictionary sowpods;
Dictionary twl98;

#ifdef COLOR
ifstream sowpods;
ifstream twl98;
#endif

int write_page_bylen(int l) {

        int table = 0, trow = 0, twords = 0, _trow;
        char pagename1[]=".\\web\\l .htm";
        char pagename2[]=".\\web\\l  .htm";
        ofstream wordpage;

        if (l < 10)
        {
                pagename1[7] = '0'+l;
                wordpage.open(pagename1);
        } else {
                pagename2[7] = '0'+(l/10);
                pagename2[8] = '0'+(l % 10);
                wordpage.open(pagename2);
        }

        _trow = 30 / l;

        if (l > 4)
                _trow = 60/l;

        wordpage << "<html><head><title>Words from list of length " << l << "</title></head><body><a href = \"index.htm\">Back.</a>" << endl;
        wordpage << "<p><font face=\"Courier\" size = \"2\">";
        wordpage << "<table width = 100%><tr>";

#ifdef COLOR
        sowpods >> sowword;
        twl98 >> twlword;
#endif

        while (1) {

                int istwl, issow;

                input >> loadword;

#ifdef COLOR
                istwl = stricmp(twlword, loadword);
                issow = stricmp(sowword, loadword);

                if (istwl < 0) {
                        do {
                                twl98 >> twlword;
                                istwl = stricmp(twlword, loadword);
                        } while (istwl < 0 && !twl98.eof());
                        while (strlen(twlword) != l && !twl98.eof()) {
                                twl98 >> twlword;
                                istwl = stricmp(twlword, loadword);
                        }
                }
                if (issow < 0) {
                        do {
                                sowpods >> sowword;
                                issow = stricmp(sowword, loadword);
                        } while (istwl < 0 && !sowpods.eof());
                        while (strlen(sowword) != l && !sowpods.eof()) {
                                twl98 >> sowword;
                                issow = stricmp(sowword, loadword);
                        }
                }

                if (!istwl)
                        do {
                                twl98 >> twlword;
                        } while (strlen(twlword) != l && !twl98.eof());
                if (!issow)
                        do {
                                sowpods >> sowword;
                        } while (strlen(sowword) != l && !sowpods.eof());
#endif

                if (input.eof())
                        break;

                if (strlen(loadword) != l)
                        continue;

#ifdef COLOR
                wordpage << "<td";

                if (!istwl) {
                        if (!issow) {
                                wordpage << " bgcolor=\"#00ff00\">";
                        } else {
                                wordpage << " bgcolor=\"#2f5fff\">";
                        }
                } else if (!issow) {
                        wordpage << " bgcolor=\"#ffff00\">";
                } else {
                        wordpage << ">";
                }
#else
                wordpage << "<td";

                if (twl98.is_word(loadword)) {
                        if (sowpods.is_word(loadword)) {
                                wordpage << " bgcolor=\"#00ff00\">";
                        } else {
                                wordpage << " bgcolor=\"#2f5faf\">";
                        }
                } else if (sowpods.is_word(loadword)) {
                        wordpage << " bgcolor=\"#ffff00\">";
                } else {
                        wordpage << ">";
                }

#endif
                int g;
                for (g=0; loadword[g]; ++g)
                        wordpage << toupper(loadword[g]);
                wordpage << "</td>";

                table++;
                trow++;
                twords++;

                if (trow == _trow) {
                        trow = 0;
                        wordpage << "</tr>" << endl << "<tr>";
                }

                if (table == _trow*ROWS*3) {
                        table = 0;
                        wordpage << "</tr></table><p><table width=100%%><tr>" << endl;
                }

                input >> loadword;

                if (input.eof())
                        break;
        }

        if (table) {
                        wordpage << "</tr></table><p>" << endl;
        }

        wordpage << "</font><hr>Total is " << twords << " words.<p><a href = \"index.htm\">Back.</a></body></html>" << endl;

        wordpage.close();

        return twords;

}

int write_page(int l1, int l2) {

        int table = 0, trow = 0, twords = 0;
        char pagename[]=".\\web\\  .htm";
        ofstream wordpage;

        while (loadword[1] == 0) {
                input >> loadword;
                if (input.eof())
                        return 0;
        }

        if (tolower(loadword[1]) != 'a'+l2 || tolower(loadword[0]) != 'a'+l1) {
                return 0; // don't even bother creating the page
        }

        pagename[6] = ('a' + l1);
        pagename[7] = ('a' + l2);

        wordpage.open(pagename);

        indx << "<a href=\"" << pagename + 6 << "\">" << char(l1+'a') << char(l2+'a') << "</a> " << endl;

        wordpage << "<html><head><title>Words from list beginning with " << char(l1+'a') << char(l2+'a') << "</title></head><body><a href = \"index.htm\">Back.</a>" << endl;
        wordpage << "<p><font face=\"Courier\" size = \"2\">";
        wordpage << "<table width = 100%%><tr>";

        while (1) {
                if (tolower(loadword[1]) != 'a'+l2 || tolower(loadword[0]) != 'a'+l1)
                        break;

                wordpage << "<td>";
                int g;
                for (g=0; loadword[g]; ++g)
                        wordpage << toupper(loadword[g]);
                wordpage << "</td>";

                table++;
                trow++;
                twords++;

                if (trow == TROW) {
                        trow = 0;
                        wordpage << "</tr>" << endl << "<tr>";
                }
                if (table == TROW*ROWS) {
                        table = 0;
                        wordpage << "</tr></table><p><table width=100%%><tr>" << endl;
                }

                input >> loadword;

                if (input.eof())
                        break;
        }

        if (table) {
                        wordpage << "</tr></table><p>" << endl;
        }

        wordpage << "</font><hr>Total is " << twords << " words.<p><a href = \"index.htm\">Back.</a></body></html>" << endl;
        wordpage.close();

        return twords;

}


int main(int argc, char *argv[]) {

        int total = 0, tletter;


        if (argc < 2) {
                cerr << "call: makeweb [list]" << endl;
                return -1;
        }

        cout << "Loading SOWPODS dictionary...." << endl;
        input.open("sowpods");
        sowpods.load_dictionary(input);
        input.close();
        cout << "Loading TWL98 dictionary...." << endl;
        input.open("twl98");
        twl98.load_dictionary(input);
        input.close();
        input.open(argv[1]);
        indx.open(".\\web\\index.htm");

#ifdef COLOR
        twl98.open("twl98");    // whod've thunk?
        sowpods.open("sowpods");
#endif

        indx << "<html><head><title>Browsable Word List</title></head>" << endl;
        indx << "<body><h1>Browsable Word List</h1><P><b>Browse by First Two Letters</b><p><hr><P>" << endl;

        input >> loadword;

        int e, f;

        for (e=0; e<26; ++e) {
                tletter = 0;
                for (f=0; f<26; ++f) {
                        tletter += write_page(e, f);
                }
                cout << "By letter: " << char('A' + e) << endl;
                total += tletter;
                indx << "<br><i>Total words beginning with '" << char('A'+e) << "': " << tletter << "</i><br>";
                indx << "<p><hr><p>" << endl;
        }


        input.close();
#ifdef COLOR
        twl98.close();
        sowpods.close();
#endif

        indx << "<b>Browse by word length</b><p><hr><p>" << endl;

        for (e=2; e<21; ++e) {

                input.open(argv[1]);
#ifdef COLOR
                twl98.open("twl98");
                sowpods.open("sowpods");
#endif
                indx << "<a href = \"l" << e << ".htm\">Length " << e << "</a> <i>(" << write_page_bylen(e) << " words)</i><br>";
                cout << "By length (" << e << ")" << endl;
                input.close();
#ifdef COLOR
                twl98.close();
                sowpods.close();
#endif

        }

        indx << "<p><hr><p>" << endl;
        indx << "<i>Total words in word list: " << total << "</i>" << endl;
        indx << "</body></html>" << endl;


        indx.close();

        return 0;

}
