
#include <iostream>
#include <fstream>
#include <strings.h>


int main(int argc, char **argv) {

        if (argc < 4) {
                cerr << "Format of call: merge [input1] [input2] [output]\n";
                return -1;
        }

        ifstream i1, i2;
        ofstream o1;
        int nw, tw, g;

        i1.open(argv[1]);
        i2.open(argv[2]);
        o1.open(argv[3]);

        nw = 0;
        g = 0;
        tw = 0;

        char str1[128], str2[128];

        i1 >> str1;
        i2 >> str2;

        for (;;) {

                int c;

                c = stricmp(str1, str2);

                if (!c) {
                        o1 << str1 << endl;
                        tw++;
                        if (i1.eof() || i2.eof())
                                break;
                        i1 >> str1;
                        i2 >> str2;
                } else {
                        if (c < 0) {
                                o1 << str1 << endl;
                                tw++;
                                if (i1.eof() || i2.eof())
                                        break;
                                i1 >> str1;
                        } else {
                                o1 << str2 << endl;
                                tw++;
                                cout << str2 << endl;
                                nw++;
                                if (i1.eof() || i2.eof())
                                        break;
                                i2 >> str2;
                        }
                }

                if (str1[0] == 0 || str2[0] == 0)
                        break;

        }

        if (!i1.eof()) {
                char buf[128];
                o1 << str1 << endl;
                tw++;
                while (!i1.eof()) {
                        i1 >> buf;
                        o1 << buf << endl;
                        tw++;
                }
        } else {
                char buf[128];
                o1 << str2 << endl;
                tw++;
                cout << str2 << endl;
                nw++;
                while (!i2.eof()) {
                        i2 >> buf;
                        o1 << buf << endl;
                        tw++;
                        cout << buf << endl;
                        nw++;
                }
        }

        o1.close();
        i2.close();
        i1.close();

        cout << "new words added to input1 list: " << nw << endl;
        cout << "total words in output list: " << tw << endl;

        return 0;

}
