
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


int qsorthelp(const void *v1, const void *v2) {
        return stricmp(*((char **)v1), *((char **)v2));
}

bool goodword(char *c) {

        int e;
        e = 0;

        while (c[e]) {
                if (tolower(c[e]) < 'a' || tolower(c[e]) > 'z')
                        return false;
                e++;
        }

        return true;

}

int main(int argc, char **argv) {

        char **array;
        int nw;

        if (argc < 3) {
           cout << "Proper call: sortlist [input] [output]\n";
           return -1;
        }

        ifstream i;
        ofstream o;

        array = new char * [350000];
        nw = 0;
        array[0] = new char [50];

        i.open(argv[1]);

        while (!i.eof()) {
                i >> array[nw];
                if (array[nw][0]) {
                        nw++;
                        array[nw] = new char [32];
                }
        }

        i.close();

        qsort(array, nw, sizeof(char *), qsorthelp);

        o.open(argv[2]);

        int e;
        for (e=0; e<nw; ++e) {
                if (e > 0 && !stricmp(array[e], array[e-1])) {
                        continue;
                }
                if (goodword(array[e])) {
                        o << array[e] << endl;
                }
        }

        o.close();

        return 0;

}
