
#include <iostream>
#include <fstream>
#include <string.h>


int main(int argc, char *argv[]) {

        int dis[60], conx[2] = {0,0}, conq[2] = {0,0}, conz[2] = {0,0}, e, t = 0, less9 = 0, f9t15 = 0, f16t30 = 0, more30 = 0;
        char longest[60];

        for (e=0; e<60; ++e) {
            dis[e] = 0;
        }

        if (argc < 2) {
                cerr << " Proper call: distrib [input file]\n";
                return -1;
        }

        ifstream i;
        int ml;

        i.open(argv[1]);

        ml = 0;

        while (!i.eof()) {

                char buffer[60];
                int l;

                i >> buffer;

                l = strlen(buffer);

                if (strstr(buffer, "x")) {
                        conx[0]++;
                        if (l < 9)
                                conx[1]++;
                }
                if (strstr(buffer, "q")) {
                        conq[0]++;
                        if (l < 9)
                                conq[1]++;
                }
                if (strstr(buffer, "z")) {
                        conz[0]++;
                        if (l < 9)
                                conz[1]++;

                }

                t++;
                if (l < 9)
                        less9++;
                if (l > 8 && l <16)
                        f9t15++;
                if (l > 15 && l < 31)
                        f16t30++;
                if (l > 30)
                        more30++;

                dis[l-1]++;

                if (l > ml) {
                        ml = l;
                        strcpy(longest, buffer);
                }

        }

        i.close();

        cout << endl << "Distribution of words in dictionary: " << endl << endl;

        for (e=0; e<ml; ++e) {

                if (dis[e])
                        cout << "Length " << (e+1) << ":\t" << dis[e] << endl;

        }

        cout << endl << "       Total words:   " << t << endl;
        cout << "       < 9 letters:   " << less9 << endl;
        cout << "       9-15 letters:  " << f9t15 << endl;
        cout << "       15-30 letters: " << f16t30 << endl;
        cout << "       30+ letters:   " << more30 << endl << endl;


        cout << endl;
        cout << "Words containing Q: " << conq[0] << " (of 1-8 letters: " << conq[1] << ")" << endl;
        cout << "Words containing X: " << conx[0] << " (of 1-8 letters: " << conx[1] << ")" << endl;
        cout << "Words containing Z: " << conz[0] << " (of 1-8 letters: " << conz[1] << ")" << endl;
        cout << endl;
        cout << " Longest word in dictionary: " << longest << endl;
        cout << endl;

        return 0;

}
