
#include <iostream>
#include <fstream>
#include <strings.h>


int main(int argc, char **argv) {

        if (argc < 4) {
                cerr << "Format of call: remove [input1] [input2] [output]\n";
                return -1;
        }

        ifstream i1, i2;
        ofstream o1;

        i1.open(argv[1]);
        i2.open(argv[2]);
        o1.open(argv[3]);

        char str1[128], str2[128];

        i1 >> str1;
        i2 >> str2;

        for (;;) {

                int c;

                c = stricmp(str1, str2);

                if (!c) {
                        if (i1.eof() || i2.eof())
                                break;
                        i1 >> str1;
                        i2 >> str2;
                } else {
                                if (c > 0) {
                                        i2 >> str2;
                                }
                                o1 << str1 << endl;
                                if (i1.eof() || i2.eof())
                                        break;
                                i1 >> str1;
                }

                if (str1[0] == 0 || str2[0] == 0)
                        break;

        }

        if (!i1.eof()) {
                char buf[128];
                o1 << str1 << endl;
                while (!i1.eof()) {
                        i1 >> buf;
                        o1 << buf << endl;
                }
        }

        o1.close();
        i2.close();
        i1.close();

        return 0;

}
