
#include <stdio.h>
#include <io.h>
#include <ctype.h>


int main(int argc, char **argv) {

        char *b;
        int l, e, sp;
        FILE *i, *o1, *o2;

        if (argc < 4) {
                fprintf(stderr, "Proper call: split [input] [output1] [output2]\n");
                return -1;
        }

        i = fopen(argv[1], "rb");
        o1 = fopen(argv[2], "wb");
        o2 = fopen(argv[3], "wb");

        l = filelength(fileno(i));

        b = (char *)malloc(l*sizeof(char));

        fread(b, 1, l, i);

        sp = l / 2;

        while (!isspace(b[sp])) {
                sp++;
        }

        b[sp] = 0;

        fwrite(b, 1, sp-1, o1);
        fwrite(b + sp + 1, 1, l-(sp+1), o2);

        fclose(o1);
        fclose(o2);
        fclose(i);

        return 0;

}
