
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <iostream>
#include <fstream>
#include <pc.h>
#include <keys.h>

#define isv(c) ((c)=='a' || (c)=='e' || (c)=='i' || (c)=='o' || (c)=='u')
#define isc(c) (!(isv(c)))
#define isdc(c) (isc(c) && c != 'n' && c != 'y' && c != 'x')
#define ishc(c) ((c) == 'x' || (c)=='z' || (c) == 'j' || (c) == 's')
#define isdi(p) (!(strnicmp(p, "nt", 2) & strnicmp(p, "ch", 2) & strnicmp(p, "th", 2) & strnicmp(p, "st", 2)))

void write_adjective(char *b, FILE *o) {

        int lenw;

        lenw = strlen(b);

        fprintf(o, "%s\n", b);
        printf(" A+: %s\n", b);

        b[lenw - 1] = 'i';
        fprintf(o, "%ser\n", b);
        printf("cA+: %ser\n", b);
        fprintf(o, "%sest\n", b);
        printf("sA+: %sest\n", b);

}


void write_word(char *b, FILE *o) {

        fprintf(o, "%s\n", b);
        printf("Add: %s\n", b);

}

void write_verb(char *b, FILE *o) {

        /* b = base word, o = output file */

        int lenw;

        lenw = strlen(b);

        fprintf(o, "%s\n", b);
        printf(" V+: %s\n", b);

        /* inflect the verb properly */

        if (isdc(b[lenw - 1]) && isv(b[lenw - 2]) && (lenw < 3 || !isv(b[lenw - 3]))) {
                // need to double the last letter

                fprintf(o, "%s%ced\n", b, b[lenw - 1]);
                printf("iV+: %s%ced\n", b, b[lenw - 1]);
                if (ishc(b[lenw - 1])) {
                        fprintf(o, "%ses\n", b);
                        printf("iV+: %ses\n", b);
                } else {
                        fprintf(o, "%ss\n", b);
                        printf("iV+: %ss\n", b);
                }
                fprintf(o, "%s%cing\n", b, b[lenw - 1]);
                printf("iV+: %s%cing\n", b, b[lenw - 1]);
        } else {

                if (ishc(b[lenw - 1])) {
                        fprintf(o, "%ses\n", b);
                        printf("iV+: %ses\n", b);
                } else {
                        if (b[4 + lenw - 1] == 'y') {
                                fprintf(o, "%sing\n", b);
                                printf("iV+: %sing\n", b);
                        } else {
                                fprintf(o, "%ss\n", b);
                                printf("iV+: %ss\n", b);
                        }
                }
                if (b[lenw - 1] != 'e') {
                        if (b[lenw - 1] != 'y') {
                                fprintf(o, "%sed\n", b);
                                fprintf(o, "%sing\n", b);
                                printf("iV+: %sed\n", b);
                                printf("iV+: %sing\n", b);
                        } else {
                                b[lenw - 1] = 'i';
                                fprintf(o, "%ses\n", b);
                                fprintf(o, "%sed\n", b);
                                printf("iV+: %ses\n", b);
                                printf("iV+: %sed\n", b);
                        }
                } else {
                        fprintf(o, "%sd\n", b);
                        printf("iV+: %sd\n", b);
                        b[lenw -1] = 'i';
                        fprintf(o, "%sng\n", b);
                        printf("iV+: %sng\n", b);
                }

        }


}

void write_noun(char *b, FILE *o) {

        /* b = base word, o = output file */

        int lenw;

        lenw = strlen(b);

        fprintf(o, "%s\n", b);
        printf(" N+: %s\n", b);

        /* add plural as appropriate */

                                switch (b[lenw - 1]) {

                                        case 'y':
                                                b[lenw - 1] = 'i';
                                                fprintf(o, "%ses\n", b);
                                                printf("pN+: %ses\n", b);
                                                break;

                                        case 'x':
                                        case 'z':
                                        case 'j':
                                                fprintf(o, "%ses\n", b);
                                                printf("pN+: %ses\n", b);
                                                break;

                                        case 's':
                                                if (b[lenw - 2] == 'u') {
                                                        /* don't pluralize words ending in "us" */
                                                        printf("pN : no plural (-us)\n");
                                                } else {
                                                        fprintf(o, "%ses\n", b);
                                                        printf("pN+: %ses\n", b);
                                                }
                                                break;

                                        case 'n':
                                                if (lenw >= 3 && !strcmp(b + lenw - 3, "man")) {
                                                        b[lenw - 2] = 'e';
                                                        fprintf(o, "%s\n", b);
                                                        printf("pN+: %s\n", b);
                                                        break;
                                                }

                                        default:
                                                if (b[lenw - 1] == 'h' && (b[lenw - 2] == 'c' || b[lenw - 2] == 's')) {
                                                        fprintf(o, "%ses\n", b);
                                                        printf("pN+: %ses\n", b);
                                                } else {
                                                        fprintf(o, "%ss\n", b);
                                                        printf("pN+: %ss\n", b);
                                                }
                                                break;

                                }

}


int main(int argc, char **argv) {

        char buffer[128];
        ifstream input;
        ofstream cull;
        bool cont;
        FILE *o;

        if (argc < 4) {
                cout << " Proper call: switch [input list] [output list] [cull list]\n";
                return -1;
        }

        input.open(argv[1]);
        cull.open(argv[3]);
        o = fopen(argv[2], "w");

        cont = true;

        while (1) {

                int k;

                if (cont)
                        input >> buffer;
                cout << buffer << "    ---?" << endl;

                cont = true;
                k = getkey();           // query user

                switch (k) {

                        case 'a':
                        case 'A':

                                // add as-is unequivically
                                write_word(buffer, o);
                                break;

                        case 'j':
                        case 'J':

                                // add to list as an adjective
                                write_adjective(buffer, o);
                                break;

                        case 'n':
                        case 'N':

                                // add to list as a noun
                                write_noun(buffer, o);
                                break;

                        case 'q':
                        case 'Q':

                                // quit proggie
                                cull.close();
                                input.close();
                                fclose(o);
                                return 0;

                        case 'v':
                        case 'V':
                                // add to list as a verb
                                write_verb(buffer, o);
                                break;

                        case 'x':
                        case 'X':
                                // skip this word
                                cull << buffer << endl;
                                break;

                        case '-':
                        case ',':
                                // insert an alert in the output file
                                fprintf(o, "   ---- alert\n");
                                printf("\t\t(alert)\n");
                                cont = false;
                                break;

                        default:
                                // retry
                                cont = false;
                                break;

                }

                if (input.eof())
                        break;

        }

        return 0;

}
